# About UDFs/Custom Fields and UDTs

In the BaseSpace Clarity LIMS web interface, in the Custom Fields configuration screen, administrators can add user-defined information by adding custom fields (global fields or master step fields). At this time, user-defined types (UDTs) are only supported in the API.

Use these custom fields to configure storage locations for data that annotates project, submitted sample, step, derived sample, measurement, and file information recorded in a workflow.

All XML element attributes and values are text. Before using the value in a script, you may want to convert to a strongly-typed variable such as a number or date type.

For details on the formats used in XML, see [Working with User-Defined Fields (UDF) and Types (UDT)](/clarity-lims/api-and-database/api-docs/rest/working-with-user-defined-fields-udf-and-types-udt.md).

{% hint style="info" %}
When updating multiple process outputs or containers, you can increase the script execution speed by using batch operations.
{% endhint %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://help.connected.illumina.com/clarity-lims/api-and-database/api-docs/cookbook/working-with-user-defined-fields-custom-fields/about-udfs-custom-fields-and-udts.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
